Index: palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4225)
+++ palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4226)
@@ -25,4 +25,10 @@
 ! -----------------
 ! $Id$
+! - Data input moved into nesting_offl_mod
+! - check rephrased
+! - time variable is now relative to time_utc_init
+! - Define module specific data type for offline nesting in nesting_offl_mod
+! 
+! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
 ! 
@@ -99,6 +105,27 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  dzw, e, diss, pt, pt_init, q, q_init, s, u, u_init, ug, v,      &
-               v_init, vg, w, zu, zw
+        ONLY:  dzw,                                                            &
+               e,                                                              &
+               diss,                                                           &
+               pt,                                                             &
+               pt_init,                                                        &
+               q,                                                              &
+               q_init,                                                         &
+               rdf,                                                            &
+               rdf_sc,                                                         &
+               s,                                                              &
+               u,                                                              &
+               u_init,                                                         &
+               ug,                                                             &
+               v,                                                              &
+               v_init,                                                         &
+               vg,                                                             &
+               w,                                                              &
+               zu,                                                             &
+               zw
+
+    USE basic_constants_and_equations_mod,                                     &
+           ONLY:  g,                                                           &
+                  pi
                  
     USE chem_modules,                                                          &
@@ -111,4 +138,5 @@
                bc_dirichlet_r,                                                 &
                bc_dirichlet_s,                                                 &
+               coupling_char,                                                  &
                dt_3d,                                                          &
                dz,                                                             &
@@ -132,5 +160,10 @@
                
     USE cpulog,                                                                &
-        ONLY:  cpu_log, log_point
+        ONLY:  cpu_log,                                                        &
+               log_point,                                                      &
+               log_point_s
+
+    USE date_and_time_mod,                                                     &
+        ONLY:  time_utc_init
 
     USE grid_variables
@@ -145,10 +178,104 @@
 
     USE netcdf_data_input_mod,                                                 &
-        ONLY:  nest_offl
-        
+        ONLY:  check_existence,                                                &
+               close_input_file,                                               &
+               get_dimension_length,                                           &
+               get_variable,                                                   &
+               get_variable_pr,                                                &
+               input_pids_dynamic,                                             &
+               inquire_num_variables,                                          &
+               inquire_variable_names,                                         &
+               input_file_dynamic,                                             &
+               num_var_pids,                                                   &
+               open_read_file,                                                 &
+               pids_id
+
     USE pegrid
 
+    IMPLICIT NONE
+
+!
+!-- Define data type for nesting in larger-scale models like COSMO.
+!-- Data type comprises u, v, w, pt, and q at lateral and top boundaries.
+    TYPE nest_offl_type
+
+       CHARACTER(LEN=16) ::  char_l = 'ls_forcing_left_'  !< leading substring for variables at left boundary 
+       CHARACTER(LEN=17) ::  char_n = 'ls_forcing_north_' !< leading substring for variables at north boundary  
+       CHARACTER(LEN=17) ::  char_r = 'ls_forcing_right_' !< leading substring for variables at right boundary  
+       CHARACTER(LEN=17) ::  char_s = 'ls_forcing_south_' !< leading substring for variables at south boundary 
+       CHARACTER(LEN=15) ::  char_t = 'ls_forcing_top_'   !< leading substring for variables at top boundary 
+
+       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names         !< list of variable in dynamic input file
+       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_l  !< names of mesoscale nested chemistry variables at left boundary
+       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_n  !< names of mesoscale nested chemistry variables at north boundary
+       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_r  !< names of mesoscale nested chemistry variables at right boundary
+       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_s  !< names of mesoscale nested chemistry variables at south boundary
+       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_t  !< names of mesoscale nested chemistry variables at top boundary
+
+       INTEGER(iwp) ::  nt     !< number of time levels in dynamic input file
+       INTEGER(iwp) ::  nzu    !< number of vertical levels on scalar grid in dynamic input file
+       INTEGER(iwp) ::  nzw    !< number of vertical levels on w grid in dynamic input file
+       INTEGER(iwp) ::  tind   !< time index for reference time in mesoscale-offline nesting
+       INTEGER(iwp) ::  tind_p !< time index for following time in mesoscale-offline nesting
+
+       LOGICAL      ::  init         = .FALSE. !< flag indicating that offline nesting is already initialized
+
+       LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_l !< flags inidicating whether left boundary data for chemistry is in dynamic input file  
+       LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_n !< flags inidicating whether north boundary data for chemistry is in dynamic input file 
+       LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_r !< flags inidicating whether right boundary data for chemistry is in dynamic input file 
+       LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_s !< flags inidicating whether south boundary data for chemistry is in dynamic input file 
+       LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_t !< flags inidicating whether top boundary data for chemistry is in dynamic input file 
+
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  surface_pressure !< time dependent surface pressure
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  time             !< time levels in dynamic input file
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  zu_atmos         !< vertical levels at scalar grid in dynamic input file
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  zw_atmos         !< vertical levels at w grid in dynamic input file
+
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ug         !< domain-averaged geostrophic component
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vg         !< domain-averaged geostrophic component
+
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_left   !< u-component at left boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_left   !< v-component at left boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_left   !< w-component at left boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  q_left   !< mixing ratio at left boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_left  !< potentital temperautre at left boundary
+
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_north  !< u-component at north boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_north  !< v-component at north boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_north  !< w-component at north boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  q_north  !< mixing ratio at north boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_north !< potentital temperautre at north boundary
+
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_right  !< u-component at right boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_right  !< v-component at right boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_right  !< w-component at right boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  q_right  !< mixing ratio at right boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_right !< potentital temperautre at right boundary
+
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_south  !< u-component at south boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_south  !< v-component at south boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_south  !< w-component at south boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  q_south  !< mixing ratio at south boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_south !< potentital temperautre at south boundary
+
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_top    !< u-component at top boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_top    !< v-component at top boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_top    !< w-component at top boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  q_top    !< mixing ratio at top boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_top   !< potentital temperautre at top boundary
+       
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  chem_left   !< chemical species at left boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  chem_north  !< chemical species at left boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  chem_right  !< chemical species at left boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  chem_south  !< chemical species at left boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  chem_top    !< chemical species at left boundary
+
+    END TYPE nest_offl_type
+
+    REAL(wp) ::  fac_dt              !< interpolation factor
     REAL(wp) ::  zi_ribulk = 0.0_wp  !< boundary-layer depth according to bulk Richardson criterion, i.e. the height where Ri_bulk exceeds the critical
-                                     !< bulk Richardson number of 0.25
+                                     !< bulk Richardson number of 0.2
+
+    TYPE(nest_offl_type) ::  nest_offl  !< data structure for data input at lateral and top boundaries (provided by Inifor) 
     
     SAVE
@@ -159,6 +286,9 @@
            nesting_offl_calc_zi,                                               &
            nesting_offl_check_parameters,                                      &
+           nesting_offl_geostrophic_wind,                                      &
            nesting_offl_header,                                                &
            nesting_offl_init,                                                  &
+           nesting_offl_input,                                                 &
+           nesting_offl_interpolation_factor,                                  &
            nesting_offl_mass_conservation,                                     &
            nesting_offl_parin 
@@ -178,4 +308,8 @@
        MODULE PROCEDURE nesting_offl_check_parameters
     END INTERFACE nesting_offl_check_parameters
+
+    INTERFACE nesting_offl_geostrophic_wind
+       MODULE PROCEDURE nesting_offl_geostrophic_wind
+    END INTERFACE nesting_offl_geostrophic_wind
     
     INTERFACE nesting_offl_header
@@ -186,4 +320,12 @@
        MODULE PROCEDURE nesting_offl_init
     END INTERFACE nesting_offl_init
+
+    INTERFACE nesting_offl_input
+       MODULE PROCEDURE nesting_offl_input
+    END INTERFACE nesting_offl_input
+
+    INTERFACE nesting_offl_interpolation_factor
+       MODULE PROCEDURE nesting_offl_interpolation_factor
+    END INTERFACE nesting_offl_interpolation_factor
            
     INTERFACE nesting_offl_mass_conservation
